stages:
  - validate
  - test
  - deploy

checkstyle:
  stage: validate
  tags:
    - docker
  image:
    name: python:3.8
    pull_policy: if-not-present
  before_script:
    - pip install pycodestyle>=2.8.0
  script:
    - pycodestyle --show-source --show-pep8 --exclude=drb/topics/geojson/_version.py,versioneer.py

license_check:
  stage: validate
  tags:
    - docker
  image:
    name: python:3.8
    pull_policy: if-not-present
  before_script:
    - pip install -r requirements.txt liccheck>=0.7.2
  script:
    - liccheck -s liccheck.ini -r requirements.txt

unittest_3.8:
  stage: test
  tags:
    - docker
  image:
    name: python:3.8
    pull_policy: if-not-present
  before_script:
    - pip install -r requirements.txt build
    - python -m build
  script:
    - python -m unittest

unittest_3.11:
  stage: test
  tags:
    - docker
  image:
    name: python:3.8
    pull_policy: if-not-present
  before_script:
    - pip install -r requirements.txt build
    - python -m build
  script:
    - python -m unittest

release:
  stage: deploy
  tags:
    - docker
  image:
    name: python:3.8
    pull_policy: if-not-present
  before_script:
    - pip install -r requirements.txt wheel build twine
  script:
    - python -m build
    - pip install dist/drb-topic-geojson-$CI_COMMIT_TAG.tar.gz
    - python -m twine upload dist/*
  only:
    - tags
